module TuringEntf0 where

-- Turingmaschine entfernt Nullen aus Folge von Nullen und Einsen
-- Prfungsaufgabe im Abitur 2009

entf0 :: [Char] -> [Char]
entf0 s = delta (['*']++s++['*']) 1 0	-- Bandbeschriftung Bandposition Zustand

-- delta :: Bandbeschriftung Bandposition Folgezustand

delta :: [Char] -> Int -> Int -> [Char]
delta s b z
	|b<0 = error "Fehler"
	|z==0 && ein=='0' = delta (schreibe s b '1') (b-1) 1
	|z==0 && ein=='1' = delta s (b+1) 0
	|z==0 && ein=='*' = delta s (b-1) 3
	|z==1 && ein=='0' = delta (schreibe s b '*') (b+1) 2
	|z==1 && ein=='1' = delta s (b-1) 1
	|z==1 && ein=='*' = delta s (b+1) 2
	|z==2 && ein=='0' = delta (schreibe s b '*') b 2
	|z==2 && ein=='1' = delta (schreibe s b '*') (b+1) 0
	|z==2 && ein=='*' = delta s b 2
	|z==3 && ein=='0' = delta (schreibe s b '*') (b+1) 4
	|z==3 && ein=='1' = delta s (b-1) 3
	|z==3 && ein=='*' = delta s (b+1) 4
	|z==4 = tail (init s)               -- erstes und letztes '*' abschneiden
	|otherwise = error "Falsches Eingabezeichen!"
	where ein = head (drop b s)
	
-- schreibe :: ersetzt im String s das Zeichen an der Bandposition durch das angegebene Zeichen
-- schreibe :: String Bandposition Zeichen

schreibe :: [Char] -> Int -> Char -> [Char]
schreibe "" b c = ""
schreibe s b c = take b s++[c]++tail (drop b s)

-- take 3 "*11101*" --> "*11" die ersten drei Zeichen
-- drop 3 "*11101*" --> "101*" die Liste ohne die ersten drei Zeichen

testentf :: [[Char]] -> [[Char]]
testentf [] = []
testentf (x:xs) = entf0 x:testentf xs

test :: [[Char]]
test = testentf ["","0","1","01","10","11","100","101","110","111","1101","0101"]

--              ["","*","1","*1","*1","11","**1","*11","*11","111","*111","**11"] 